// _] (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*5*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i;
	unsigned char id1a[] = "Degital DevilSys ";
	unsigned char id1b[] = "Desital DevilSys ";
	unsigned char id1c[] = "Digital DevilSys ";
	unsigned char id2[]  = "Story        Sys ";

	// ȃf[^ (Disk A)
	struct fpos ma1[] =
	{
		{ 0x12, 0x03, 0x0800 },	// Y
		{ 0x12, 0x05, 0x0800 },	// Izanami...
		{ 0x17, 0x02, 0x0400 },	// S[M̌C
		{ 0x18, 0x03, 0x0400 },	// Yumiko...
		{ 0x23, 0x05, 0x2000 },	// Romantic Hell
		{ 0x25, 0x03, 0x1400 },	// Bright Morning
		{ 0x26, 0x03, 0x1400 },	// Major II
		{ 0x00, 0x00, 0x0000 },	// 
	};

	// ȃf[^ (Disk B)
	struct fpos ma2[] =
	{
		{ 0x4a, 0x02, 0x0800 },	// Magnetic Magician
		{ 0x4a, 0x04, 0x0800 },	// A Statuette of loser
		{ 0x4b, 0x01, 0x0800 },	// P̒
		{ 0x4c, 0x04, 0x0400 },	// Over the moon
		{ 0x4f, 0x01, 0x0400 },	// Si-Si-Si
		{ 0x4f, 0x04, 0x0800 },	// Running Star
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x13);
		disk.SetRecordRange(0x01,0x05);
		// IPL̕ŃfBXN𔻒
		if (!memcmp(&buff[1], id1a, sizeof(id1a)) ||
		    !memcmp(&buff[1], id1b, sizeof(id1b)) ||
		    !memcmp(&buff[1], id1c, sizeof(id1c)))
		{
			printf("DISK 0 F܂.\n");
			// CvO
			fcut("OPMDRV", 0x27, 0x13, 0x01, 0x03, 0x03, 0x0000, 0x0c00);
			fcut("PSGDRV", 0x28, 0x14, 0x00, 0x01, 0x03, 0x0000, 0x0800);

			// ȃf[^̐؂o
			for (i=0; ma1[i].trk; i++)
			{
				sprintf(fname,"MA0%02d",i);
				fcut(fname, ma1[i].trk, ma1[i].trk>>1, ma1[i].trk&1, ma1[i].sec, 0x03, 0x0000, ma1[i].size);
			}
		}
		else if (!memcmp(&buff[1], id2, sizeof(id2)-1))
		{
			printf("Disk 1 F܂.\n");

			// ȃf[^̐؂o
			for (i=0; ma2[i].trk; i++)
			{
				sprintf(fname,"MA1%02d",i);
				fcut(fname, ma2[i].trk, ma2[i].trk>>1, ma2[i].trk&1, ma2[i].sec, 0x03, 0x0000, ma2[i].size);
			}
		}
	}
	return 0;
}

